diff --git a/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/PhaseSystems/MomentumTransferPhaseSystem/MomentumTransferPhaseSystem.H b/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/PhaseSystems/MomentumTransferPhaseSystem/MomentumTransferPhaseSystem.H
index be5d48ea1..8966e3a78 100644
--- a/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/PhaseSystems/MomentumTransferPhaseSystem/MomentumTransferPhaseSystem.H
+++ b/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/PhaseSystems/MomentumTransferPhaseSystem/MomentumTransferPhaseSystem.H
@@ -2,7 +2,7 @@
   =========                 |
   \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
    \\    /   O peration     | Website:  https://openfoam.org
-    \\  /    A nd           | Copyright (C) 2015-2019 OpenFOAM Foundation
+    \\  /    A nd           | Copyright (C) 2015-2020 OpenFOAM Foundation
      \\/     M anipulation  |
 -------------------------------------------------------------------------------
 License
@@ -134,8 +134,83 @@ private:
         > turbulentDispersionModelTable;
 
 
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Begin HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
+protected:
+
+    // Protected typedefs
+
+        typedef HashPtrTable
+        <
+            volVectorField,
+            phasePairKey,
+            phasePairKey::hash
+        > FlTable;
+
+        typedef HashPtrTable
+        <
+            surfaceScalarField,
+            phasePairKey,
+            phasePairKey::hash
+        > FlfTable;
+
+        typedef HashPtrTable
+        <
+            volVectorField,
+            phasePairKey,
+            phasePairKey::hash
+        > FwTable;
+
+        typedef HashPtrTable
+        <
+            surfaceScalarField,
+            phasePairKey,
+            phasePairKey::hash
+        > FwfTable;
+
+        typedef HashPtrTable
+        <
+            volVectorField,
+            phasePairKey,
+            phasePairKey::hash
+        > FtTable;
+
+        typedef HashPtrTable
+        <
+            surfaceScalarField,
+            phasePairKey,
+            phasePairKey::hash
+        > FtfTable;
+
+
+private:
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ End HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
+
+
     // Private Data
 
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Begin HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
+        //- Switch for correctFixedFluxBCs in BlendedInterfacialModel
+        Switch correctFixedFluxBCs_;
+
+        //- Lift forces
+        FlTable Fls_;
+
+        //- Face lift forces
+        FlfTable Flfs_;
+
+        //- Wall lubrication forces
+        FwTable Fws_;
+
+        //- Face wall lubrication forces
+        FwfTable Fwfs_;
+
+        //- Turbulent dispersion forces
+        FtTable Fts_;
+
+        //- Face Turbulent dispersion forces
+        FtfTable Ftfs_;
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ End HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
+
         //- Drag coefficients
         KdTable Kds_;
 
@@ -299,6 +374,68 @@ public:
             const PtrList<surfaceScalarField>& rAUfs
         ) const;
 
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Begin HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
+        //- Return the drag coefficient for all phase-pairs
+        virtual const KdTable& Kds() const
+        {
+            return Kds_;
+        };
+
+        //- Return the face drag coefficient for all phase-pairs
+        virtual const KdfTable& Kdfs() const
+        {
+            return Kdfs_;
+        };
+
+        //- Return the virtual mass force coefficient for all phase-pairs
+        virtual const VmTable& Vms() const
+        {
+            return Vms_;
+        };
+
+        //- Return the virtual face mass force coefficient for all phase-pairs
+        virtual const VmfTable& Vmfs() const
+        {
+            return Vmfs_;
+        };
+
+        //- Return the lift force for all phase-pairs
+        virtual const FlTable& Fls() const
+        {
+            return Fls_;
+        };
+
+        //- Return the face lift force for all phase-pairs
+        virtual const FlfTable& Flfs() const
+        {
+            return Flfs_;
+        };
+
+        //- Return the wall lubrication force for all phase-pairs
+        virtual const FwTable& Fws() const
+        {
+            return Fws_;
+        };
+
+        //- Return the face wall lubrication force for all phase-pairs
+        virtual const FwfTable& Fwfs() const
+        {
+            return Fwfs_;
+        };
+
+        //- Return the turbulent dispersion force for all phase-pairs
+        virtual const FtTable& Fts() const
+        {
+            return Fts_;
+        };
+
+        //- Return the face turbulent dispersion force for all phase-pairs
+        virtual const FtfTable& Ftfs() const
+        {
+            return Ftfs_;
+        };
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ End HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
+
         //- Read base phaseProperties dictionary
         virtual bool read();
 };
diff --git a/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/phaseModel/MovingPhaseModel/MovingPhaseModel.C b/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/phaseModel/MovingPhaseModel/MovingPhaseModel.C
index 8b2069d67..2445f1ce1 100644
--- a/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/phaseModel/MovingPhaseModel/MovingPhaseModel.C
+++ b/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/phaseModel/MovingPhaseModel/MovingPhaseModel.C
@@ -2,7 +2,7 @@
   =========                 |
   \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
    \\    /   O peration     | Website:  https://openfoam.org
-    \\  /    A nd           | Copyright (C) 2015-2019 OpenFOAM Foundation
+    \\  /    A nd           | Copyright (C) 2015-2020 OpenFOAM Foundation
      \\/     M anipulation  |
 -------------------------------------------------------------------------------
 License
@@ -559,4 +559,14 @@ Foam::MovingPhaseModel<BasePhaseModel>::pPrime() const
 }
 
 
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Begin HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
+template<class BasePhaseModel>
+Foam::tmp<Foam::fvVectorMatrix>
+Foam::MovingPhaseModel<BasePhaseModel>::divDevRhoReff(volVectorField& U) const
+{
+    return turbulence_->divDevRhoReff(U);
+}
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ End HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
+
+
 // ************************************************************************* //
diff --git a/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/phaseModel/MovingPhaseModel/MovingPhaseModel.H b/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/phaseModel/MovingPhaseModel/MovingPhaseModel.H
index 546b62da3..5697fbbbf 100644
--- a/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/phaseModel/MovingPhaseModel/MovingPhaseModel.H
+++ b/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/phaseModel/MovingPhaseModel/MovingPhaseModel.H
@@ -2,7 +2,7 @@
   =========                 |
   \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
    \\    /   O peration     | Website:  https://openfoam.org
-    \\  /    A nd           | Copyright (C) 2015-2019 OpenFOAM Foundation
+    \\  /    A nd           | Copyright (C) 2015-2020 OpenFOAM Foundation
      \\/     M anipulation  |
 -------------------------------------------------------------------------------
 License
@@ -246,6 +246,11 @@ public:
             //- Return the phase-pressure'
             //  (derivative of phase-pressure w.r.t. phase-fraction)
             virtual tmp<volScalarField> pPrime() const;
+
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Begin HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
+            //- Return the turbulent term for the momentum equation
+            virtual tmp<fvVectorMatrix> divDevRhoReff(volVectorField& U) const;
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ End HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
 };
 
 
diff --git a/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/phaseModel/StationaryPhaseModel/StationaryPhaseModel.C b/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/phaseModel/StationaryPhaseModel/StationaryPhaseModel.C
index 7c6e9c368..fda4b3407 100644
--- a/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/phaseModel/StationaryPhaseModel/StationaryPhaseModel.C
+++ b/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/phaseModel/StationaryPhaseModel/StationaryPhaseModel.C
@@ -2,7 +2,7 @@
   =========                 |
   \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
    \\    /   O peration     | Website:  https://openfoam.org
-    \\  /    A nd           | Copyright (C) 2015-2019 OpenFOAM Foundation
+    \\  /    A nd           | Copyright (C) 2015-2020 OpenFOAM Foundation
      \\/     M anipulation  |
 -------------------------------------------------------------------------------
 License
@@ -377,4 +377,21 @@ Foam::StationaryPhaseModel<BasePhaseModel>::pPrime() const
 }
 
 
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Begin HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
+template<class BasePhaseModel>
+Foam::tmp<Foam::fvVectorMatrix>
+Foam::StationaryPhaseModel<BasePhaseModel>::divDevRhoReff
+(
+    volVectorField& U
+) const
+{
+    FatalErrorInFunction
+        << "Cannot access the turbulent term of a stationary phase"
+        << exit(FatalError);
+
+    return fvm::Su(U, U);
+}
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ End HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
+
+
 // ************************************************************************* //
diff --git a/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/phaseModel/StationaryPhaseModel/StationaryPhaseModel.H b/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/phaseModel/StationaryPhaseModel/StationaryPhaseModel.H
index 6279e0cef..91a93c2b4 100644
--- a/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/phaseModel/StationaryPhaseModel/StationaryPhaseModel.H
+++ b/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/phaseModel/StationaryPhaseModel/StationaryPhaseModel.H
@@ -2,7 +2,7 @@
   =========                 |
   \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
    \\    /   O peration     | Website:  https://openfoam.org
-    \\  /    A nd           | Copyright (C) 2015-2019 OpenFOAM Foundation
+    \\  /    A nd           | Copyright (C) 2015-2020 OpenFOAM Foundation
      \\/     M anipulation  |
 -------------------------------------------------------------------------------
 License
@@ -178,6 +178,11 @@ public:
             //- Return the phase-pressure'
             //  (derivative of phase-pressure w.r.t. phase-fraction)
             virtual tmp<volScalarField> pPrime() const;
+
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Begin HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
+            //- Return the turbulent term for the momentum equation
+            virtual tmp<fvVectorMatrix> divDevRhoReff(volVectorField& U) const;
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ End HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
 };
 
 
diff --git a/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/phaseModel/phaseModel/phaseModel.C b/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/phaseModel/phaseModel/phaseModel.C
index e6c030632..e478f6c5f 100644
--- a/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/phaseModel/phaseModel/phaseModel.C
+++ b/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/phaseModel/phaseModel/phaseModel.C
@@ -2,7 +2,7 @@
   =========                 |
   \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
    \\    /   O peration     | Website:  https://openfoam.org
-    \\  /    A nd           | Copyright (C) 2015-2019 OpenFOAM Foundation
+    \\  /    A nd           | Copyright (C) 2015-2020 OpenFOAM Foundation
      \\/     M anipulation  |
 -------------------------------------------------------------------------------
 License
@@ -68,7 +68,10 @@ Foam::phaseModel::phaseModel
         dimless,
         fluid.subDict(phaseName).lookup("residualAlpha")
     ),
-    alphaMax_(fluid.subDict(phaseName).lookupOrDefault("alphaMax", 1.0))
+    alphaMax_(fluid.subDict(phaseName).lookupOrDefault("alphaMax", 1.0)),
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Begin HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
+    continuous_(fluid.subDict(phaseName).lookupOrDefault("continuous", false))
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ End HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
 {
     diameterModel_ = diameterModel::New(fluid.subDict(phaseName), *this);
 }
@@ -125,6 +128,14 @@ Foam::scalar Foam::phaseModel::alphaMax() const
 }
 
 
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Begin HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
+bool Foam::phaseModel::continuous() const
+{
+    return continuous_;
+}
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ End HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
+
+
 Foam::tmp<Foam::volScalarField> Foam::phaseModel::d() const
 {
     return diameterModel_().d();
diff --git a/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/phaseModel/phaseModel/phaseModel.H b/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/phaseModel/phaseModel/phaseModel.H
index 77db9e7b8..60c1fad1f 100644
--- a/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/phaseModel/phaseModel/phaseModel.H
+++ b/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/phaseModel/phaseModel/phaseModel.H
@@ -2,7 +2,7 @@
   =========                 |
   \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
    \\    /   O peration     | Website:  https://openfoam.org
-    \\  /    A nd           | Copyright (C) 2015-2019 OpenFOAM Foundation
+    \\  /    A nd           | Copyright (C) 2015-2020 OpenFOAM Foundation
      \\/     M anipulation  |
 -------------------------------------------------------------------------------
 License
@@ -75,6 +75,11 @@ class phaseModel
         //- Optional maximum phase-fraction (e.g. packing limit)
         scalar alphaMax_;
 
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Begin HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
+        //- Morphology of phase (default is false, i.e. dispersed)
+        const Switch continuous_;
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ End HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
+
         //- Diameter model
         autoPtr<diameterModel> diameterModel_;
 
@@ -177,6 +182,11 @@ public:
         //- Return the maximum phase-fraction (e.g. packing limit)
         scalar alphaMax() const;
 
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Begin HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
+        //- Return true if phase is continuous
+        bool continuous() const;
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ End HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
+
         //- Return the Sauter-mean diameter
         tmp<volScalarField> d() const;
 
@@ -417,6 +427,14 @@ public:
             //- Return the phase-pressure'
             //  (derivative of phase-pressure w.r.t. phase-fraction)
             virtual tmp<volScalarField> pPrime() const = 0;
+
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Begin HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
+            //- Return the turbulent term for the momentum equation
+            virtual tmp<fvVectorMatrix> divDevRhoReff
+            (
+                volVectorField& U
+            ) const = 0;
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ End HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
 };
 
 
diff --git a/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/phasePair/phasePair/phasePair.C b/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/phasePair/phasePair/phasePair.C
index 079f95714..e16ab2306 100644
--- a/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/phasePair/phasePair/phasePair.C
+++ b/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/phasePair/phasePair/phasePair.C
@@ -2,7 +2,7 @@
   =========                 |
   \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
    \\    /   O peration     | Website:  https://openfoam.org
-    \\  /    A nd           | Copyright (C) 2014-2018 OpenFOAM Foundation
+    \\  /    A nd           | Copyright (C) 2014-2020 OpenFOAM Foundation
      \\/     M anipulation  |
 -------------------------------------------------------------------------------
 License
@@ -104,7 +104,26 @@ Foam::word Foam::phasePair::otherName() const
 
 Foam::tmp<Foam::volScalarField> Foam::phasePair::rho() const
 {
-    return phase1()*phase1().rho() + phase2()*phase2().rho();
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Begin HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
+    volScalarField rhoMin(min(phase1().rho(), phase2().rho()));
+    volScalarField rhoMax(max(phase1().rho(), phase2().rho()));
+
+    return
+        min
+        (
+            max
+            (
+                phase1()*phase1().rho() + phase2()*phase2().rho()
+               /max
+                (
+                    phase1() + phase2(),
+                    phase1().residualAlpha() + phase2().residualAlpha()
+                ),
+                rhoMin
+            ),
+            rhoMax
+        );
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ End HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
 }
 
 
diff --git a/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/phaseSystem/phaseSystem.C b/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/phaseSystem/phaseSystem.C
index 81d474936..98dc8fe79 100644
--- a/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/phaseSystem/phaseSystem.C
+++ b/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/phaseSystem/phaseSystem.C
@@ -2,7 +2,7 @@
   =========                 |
   \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
    \\    /   O peration     | Website:  https://openfoam.org
-    \\  /    A nd           | Copyright (C) 2015-2019 OpenFOAM Foundation
+    \\  /    A nd           | Copyright (C) 2015-2020 OpenFOAM Foundation
      \\/     M anipulation  |
 -------------------------------------------------------------------------------
 License
@@ -163,6 +163,9 @@ Foam::phaseSystem::phaseSystem
     label stationaryPhasei = 0;
     label anisothermalPhasei = 0;
     label multiComponentPhasei = 0;
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Begin HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
+    label continuousPhasei = 0;
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ End HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
     forAll(phaseModels_, phasei)
     {
         phaseModel& phase = phaseModels_[phasei];
@@ -170,16 +173,25 @@ Foam::phaseSystem::phaseSystem
         stationaryPhasei += phase.stationary();
         anisothermalPhasei += !phase.isothermal();
         multiComponentPhasei += !phase.pure();
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Begin HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
+        continuousPhasei += phase.continuous();
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ End HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
     }
     movingPhaseModels_.resize(movingPhasei);
     stationaryPhaseModels_.resize(stationaryPhasei);
     anisothermalPhaseModels_.resize(anisothermalPhasei);
     multiComponentPhaseModels_.resize(multiComponentPhasei);
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Begin HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
+    continuousPhaseModels_.resize(continuousPhasei);
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ End HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
 
     movingPhasei = 0;
     stationaryPhasei = 0;
     anisothermalPhasei = 0;
     multiComponentPhasei = 0;
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Begin HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
+    continuousPhasei = 0;
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ End HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
     forAll(phaseModels_, phasei)
     {
         phaseModel& phase = phaseModels_[phasei];
@@ -199,7 +211,36 @@ Foam::phaseSystem::phaseSystem
         {
             multiComponentPhaseModels_.set(multiComponentPhasei ++, &phase);
         }
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Begin HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
+        if (phase.continuous())
+        {
+            continuousPhaseModels_.set(continuousPhasei ++, &phase);
+        }
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ End HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
+    }
+
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Begin HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
+    if (!continuousPhaseModels_.empty())
+    {
+        Info<< "Continuous phases:";
+        forAll(continuousPhaseModels_, phasei)
+        {
+            Info<< " " << continuousPhaseModels_[phasei].name();
+        }
+        Info<< endl;
+    }
+
+    // Detect incompressibility
+    incompressible_ = true;
+    forAll(phaseModels_, phasei)
+    {
+        if (!phaseModels_[phasei].incompressible())
+        {
+            incompressible_ = false;
+            break;
+        }
     }
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ End HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
 
     // Write phi
     phi_.writeOpt() = IOobject::AUTO_WRITE;
@@ -263,6 +304,29 @@ Foam::tmp<Foam::volScalarField> Foam::phaseSystem::rho() const
 }
 
 
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Begin HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
+Foam::tmp<Foam::volScalarField> Foam::phaseSystem::sumAlphaContinuous() const
+{
+    const label nPhases = movingPhaseModels_.size();
+
+    tmp<volScalarField> alphaCont
+    (
+         movingPhaseModels_[0].continuous()
+        *movingPhaseModels_[0]
+    );
+
+    for (label phasei = 1; phasei < nPhases; ++ phasei)
+    {
+        alphaCont.ref() +=
+            movingPhaseModels_[phasei].continuous()
+           *movingPhaseModels_[phasei];
+    }
+
+    return alphaCont;
+}
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ End HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
+
+
 Foam::tmp<Foam::volVectorField> Foam::phaseSystem::U() const
 {
     const label nMovingPhases = movingPhaseModels_.size();
@@ -371,6 +435,14 @@ Foam::PtrList<Foam::volScalarField> Foam::phaseSystem::dmdts() const
 }
 
 
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Begin HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
+bool Foam::phaseSystem::incompressible() const
+{
+    return incompressible_;
+}
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ End HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
+
+
 bool Foam::phaseSystem::implicitPhasePressure(const phaseModel& phase) const
 {
     return false;
@@ -494,4 +566,19 @@ Foam::tmp<Foam::surfaceScalarField> Foam::byDt(const surfaceScalarField& sf)
 }
 
 
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Begin HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
+Foam::tmp<Foam::volVectorField> Foam::byDt(const volVectorField& vf)
+{
+    if (fv::localEulerDdt::enabled(vf.mesh()))
+    {
+        return fv::localEulerDdt::localRDeltaT(vf.mesh())*vf;
+    }
+    else
+    {
+        return vf/vf.mesh().time().deltaT();
+    }
+}
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ End HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
+
+
 // ************************************************************************* //
diff --git a/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/phaseSystem/phaseSystem.H b/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/phaseSystem/phaseSystem.H
index 776e4dc6c..504787b4c 100644
--- a/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/phaseSystem/phaseSystem.H
+++ b/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/phaseSystem/phaseSystem.H
@@ -2,7 +2,7 @@
   =========                 |
   \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
    \\    /   O peration     | Website:  https://openfoam.org
-    \\  /    A nd           | Copyright (C) 2015-2019 OpenFOAM Foundation
+    \\  /    A nd           | Copyright (C) 2015-2020 OpenFOAM Foundation
      \\/     M anipulation  |
 -------------------------------------------------------------------------------
 License
@@ -153,6 +153,11 @@ protected:
         //- Multi-component phase models
         phaseModelPartialList multiComponentPhaseModels_;
 
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Begin HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
+        //- Continuous phase models
+        phaseModelPartialList continuousPhaseModels_;
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ End HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
+
         //- Phase pairs
         phasePairTable phasePairs_;
 
@@ -168,6 +173,11 @@ protected:
         //- Blending methods
         blendingMethodTable blendingMethods_;
 
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Begin HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
+        //- Incompressibility
+        bool incompressible_;
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ End HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
+
 
         // Sub Models
 
@@ -304,6 +314,11 @@ public:
             //- Access the models for phases that have multiple species
             inline phaseModelPartialList& multiComponentPhases();
 
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Begin HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
+            //- Return the models for phases that are continuous
+            inline const phaseModelPartialList& continuousPhases() const;
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ End HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
+
             //- Return the phase pairs
             inline const phasePairTable& phasePairs() const;
 
@@ -399,6 +414,11 @@ public:
             //- Return the mixture density
             tmp<volScalarField> rho() const;
 
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Begin HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
+            //- Return the total volume fraction of continuous phases
+            tmp<volScalarField> sumAlphaContinuous() const;
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ End HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
+
             //- Return the mixture velocity
             tmp<volVectorField> U() const;
 
@@ -421,6 +441,11 @@ public:
             //- Return the mass transfer rates for each phase
             virtual PtrList<volScalarField> dmdts() const;
 
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Begin HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
+            //- Return incompressibility
+            bool incompressible() const;
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ End HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
+
 
         // Transfers
 
@@ -544,6 +569,9 @@ public:
 
 tmp<volScalarField> byDt(const volScalarField& vf);
 tmp<surfaceScalarField> byDt(const surfaceScalarField& sf);
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Begin HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
+tmp<volVectorField> byDt(const volVectorField& vf);
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ End HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
 
 // * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //
 
diff --git a/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/phaseSystem/phaseSystemI.H b/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/phaseSystem/phaseSystemI.H
index 906d013cd..7c1606f03 100644
--- a/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/phaseSystem/phaseSystemI.H
+++ b/applications/solvers/multiphase/reactingEulerFoam/phaseSystems/phaseSystem/phaseSystemI.H
@@ -2,7 +2,7 @@
   =========                 |
   \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
    \\    /   O peration     | Website:  https://openfoam.org
-    \\  /    A nd           | Copyright (C) 2014-2018 OpenFOAM Foundation
+    \\  /    A nd           | Copyright (C) 2014-2020 OpenFOAM Foundation
      \\/     M anipulation  |
 -------------------------------------------------------------------------------
 License
@@ -101,6 +101,15 @@ Foam::phaseSystem::multiComponentPhases()
 }
 
 
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Begin HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
+inline const Foam::phaseSystem::phaseModelPartialList&
+Foam::phaseSystem::continuousPhases() const
+{
+    return continuousPhaseModels_;
+}
+//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ End HZDR ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
+
+
 inline const Foam::phaseSystem::phasePairTable&
 Foam::phaseSystem::phasePairs() const
 {
